
<!DOCTYPE html>

<html class="no-js" lang="en">
<head>
<meta charset="utf-8"/>
<meta content="width=device-width,initial-scale=1" name="viewport"/>
<link href="../assets/images/favicon.png" rel="icon"/>
<meta content="mkdocs-1.2.3, mkdocs-material-7.3.6" name="generator"/>
<title>Description Classes - SecuWallet</title>
<link href="../assets/stylesheets/main.a57b2b03.min.css" rel="stylesheet"/>
<link href="../assets/stylesheets/palette.3f5d1f46.min.css" rel="stylesheet"/>
<meta content="#ab47bd" name="theme-color"/>
<link crossorigin="" href="https://fonts.gstatic.com" rel="preconnect"/>
<link href="https://fonts.googleapis.com/css?family=Roboto:300,400,400i,700%7CRoboto+Mono&amp;display=fallback" rel="stylesheet"/>
<style>:root{--md-text-font-family:"Roboto";--md-code-font-family:"Roboto Mono"}</style>
<link href="https://unpkg.com/mermaid@8.5.1/dist/mermaid.css" rel="stylesheet"/>
<link href="../extra.css" rel="stylesheet"/>
</head>
<body data-md-color-accent="" data-md-color-primary="purple" data-md-color-scheme="slate" dir="ltr">
<script>function __prefix(e){return new URL("..",location).pathname+"."+e}function __get(e,t=localStorage){return JSON.parse(t.getItem(__prefix(e)))}</script>
<input autocomplete="off" class="md-toggle" data-md-toggle="drawer" id="__drawer" type="checkbox"/>
<input autocomplete="off" class="md-toggle" data-md-toggle="search" id="__search" type="checkbox"/>
<label class="md-overlay" for="__drawer"></label>
<div data-md-component="skip">
<a class="md-skip" href="#classes">
          Skip to content
        </a>
</div>
<div data-md-component="announce">
</div>
<header class="md-header" data-md-component="header">
<nav aria-label="Header" class="md-header__inner md-grid">
<a aria-label="SecuWallet" class="md-header__button md-logo" data-md-component="logo" href=".." title="SecuWallet">
<svg viewbox="0 0 24 24" xmlns="http://www.w3.org/2000/svg"><path d="M12 8a3 3 0 0 0 3-3 3 3 0 0 0-3-3 3 3 0 0 0-3 3 3 3 0 0 0 3 3m0 3.54C9.64 9.35 6.5 8 3 8v11c3.5 0 6.64 1.35 9 3.54 2.36-2.19 5.5-3.54 9-3.54V8c-3.5 0-6.64 1.35-9 3.54z"></path></svg>
</a>
<label class="md-header__button md-icon" for="__drawer">
<svg viewbox="0 0 24 24" xmlns="http://www.w3.org/2000/svg"><path d="M3 6h18v2H3V6m0 5h18v2H3v-2m0 5h18v2H3v-2z"></path></svg>
</label>
<div class="md-header__title" data-md-component="header-title">
<div class="md-header__ellipsis">
<div class="md-header__topic">
<span class="md-ellipsis">
            SecuWallet
          </span>
</div>
<div class="md-header__topic" data-md-component="header-topic">
<span class="md-ellipsis">
            
              Description Classes
            
          </span>
</div>
</div>
</div>
<label class="md-header__button md-icon" for="__search">
<svg viewbox="0 0 24 24" xmlns="http://www.w3.org/2000/svg"><path d="M9.5 3A6.5 6.5 0 0 1 16 9.5c0 1.61-.59 3.09-1.56 4.23l.27.27h.79l5 5-1.5 1.5-5-5v-.79l-.27-.27A6.516 6.516 0 0 1 9.5 16 6.5 6.5 0 0 1 3 9.5 6.5 6.5 0 0 1 9.5 3m0 2C7 5 5 7 5 9.5S7 14 9.5 14 14 12 14 9.5 12 5 9.5 5z"></path></svg>
</label>
<div class="md-search" data-md-component="search" role="dialog">
<label class="md-search__overlay" for="__search"></label>
<div class="md-search__inner" role="search">
<form class="md-search__form" name="search">
<input aria-label="Search" autocapitalize="off" autocomplete="off" autocorrect="off" class="md-search__input" data-md-component="search-query" name="query" placeholder="Search" required="" spellcheck="false" type="text"/>
<label class="md-search__icon md-icon" for="__search">
<svg viewbox="0 0 24 24" xmlns="http://www.w3.org/2000/svg"><path d="M9.5 3A6.5 6.5 0 0 1 16 9.5c0 1.61-.59 3.09-1.56 4.23l.27.27h.79l5 5-1.5 1.5-5-5v-.79l-.27-.27A6.516 6.516 0 0 1 9.5 16 6.5 6.5 0 0 1 3 9.5 6.5 6.5 0 0 1 9.5 3m0 2C7 5 5 7 5 9.5S7 14 9.5 14 14 12 14 9.5 12 5 9.5 5z"></path></svg>
<svg viewbox="0 0 24 24" xmlns="http://www.w3.org/2000/svg"><path d="M20 11v2H8l5.5 5.5-1.42 1.42L4.16 12l7.92-7.92L13.5 5.5 8 11h12z"></path></svg>
</label>
<nav aria-label="Search" class="md-search__options">
<button aria-label="Clear" class="md-search__icon md-icon" tabindex="-1" type="reset">
<svg viewbox="0 0 24 24" xmlns="http://www.w3.org/2000/svg"><path d="M19 6.41 17.59 5 12 10.59 6.41 5 5 6.41 10.59 12 5 17.59 6.41 19 12 13.41 17.59 19 19 17.59 13.41 12 19 6.41z"></path></svg>
</button>
</nav>
</form>
<div class="md-search__output">
<div class="md-search__scrollwrap" data-md-scrollfix="">
<div class="md-search-result" data-md-component="search-result">
<div class="md-search-result__meta">
            Initializing search
          </div>
<ol class="md-search-result__list"></ol>
</div>
</div>
</div>
</div>
</div>
</nav>
</header>
<div class="md-container" data-md-component="container">
<main class="md-main" data-md-component="main">
<div class="md-main__inner md-grid">
<div class="md-sidebar md-sidebar--primary" data-md-component="sidebar" data-md-type="navigation">
<div class="md-sidebar__scrollwrap">
<div class="md-sidebar__inner">
<nav aria-label="Navigation" class="md-nav md-nav--primary" data-md-level="0">
<label class="md-nav__title" for="__drawer">
<a aria-label="SecuWallet" class="md-nav__button md-logo" data-md-component="logo" href=".." title="SecuWallet">
<svg viewbox="0 0 24 24" xmlns="http://www.w3.org/2000/svg"><path d="M12 8a3 3 0 0 0 3-3 3 3 0 0 0-3-3 3 3 0 0 0-3 3 3 3 0 0 0 3 3m0 3.54C9.64 9.35 6.5 8 3 8v11c3.5 0 6.64 1.35 9 3.54 2.36-2.19 5.5-3.54 9-3.54V8c-3.5 0-6.64 1.35-9 3.54z"></path></svg>
</a>
    SecuWallet
  </label>
<ul class="md-nav__list" data-md-scrollfix="">
<li class="md-nav__item">
<a class="md-nav__link" href="../0_Poster/">
        Poster
      </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="../1_Resume/">
        Introduction
      </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="../2_CahierDesCharges/">
        Cahier des charges
      </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="../3_planning/">
        Planning
      </a>
</li>
<li class="md-nav__item md-nav__item--active md-nav__item--nested">
<input checked="" class="md-nav__toggle md-toggle" data-md-toggle="__nav_5" id="__nav_5" type="checkbox"/>
<label class="md-nav__link" for="__nav_5">
          Documentation technique
          <span class="md-nav__icon md-icon"></span>
</label>
<nav aria-label="Documentation technique" class="md-nav" data-md-level="1">
<label class="md-nav__title" for="__nav_5">
<span class="md-nav__icon md-icon"></span>
          Documentation technique
        </label>
<ul class="md-nav__list" data-md-scrollfix="">
<li class="md-nav__item">
<a class="md-nav__link" href="../4_analyseExistant/">
        Analyse de L'existant
      </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="../5_userStories/">
        User Stories
      </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="../6_interface/">
        Interfaces
      </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="../7_Architecture/">
        Architecture
      </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="../8_outilsExterne/">
        Outils et librairies externes
      </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="../9_installationEnvironnement/">
        Installation de l'environnement
      </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="../10_EncryptionBdd/">
        Encryption de base de données
      </a>
</li>
<li class="md-nav__item md-nav__item--active">
<input class="md-nav__toggle md-toggle" data-md-toggle="toc" id="__toc" type="checkbox"/>
<label class="md-nav__link md-nav__link--active" for="__toc">
          Description Classes
          <span class="md-nav__icon md-icon"></span>
</label>
<a class="md-nav__link md-nav__link--active" href="./">
        Description Classes
      </a>
<nav aria-label="Table of contents" class="md-nav md-nav--secondary">
<label class="md-nav__title" for="__toc">
<span class="md-nav__icon md-icon"></span>
      Table of contents
    </label>
<ul class="md-nav__list" data-md-component="toc" data-md-scrollfix="">
<li class="md-nav__item">
<a class="md-nav__link" href="#jwtcontroller">
    JwtController
  </a>
<nav aria-label="JwtController" class="md-nav">
<ul class="md-nav__list">
<li class="md-nav__item">
<a class="md-nav__link" href="#constante">
    Constante
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#champs">
    Champs
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#constructeur">
    Constructeur
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#methodes">
    Méthodes
  </a>
<nav aria-label="Méthodes" class="md-nav">
<ul class="md-nav__list">
<li class="md-nav__item">
<a class="md-nav__link" href="#checktoken">
    CheckToken
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#checkuserauthenticator">
    CheckUserAuthenticator
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#checkuserlogin">
    CheckUserLogin
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#gettoken">
    GetToken
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#deserializeresponse">
    DeserializeResponse
  </a>
</li>
</ul>
</nav>
</li>
</ul>
</nav>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#wallet">
    Wallet
  </a>
<nav aria-label="Wallet" class="md-nav">
<ul class="md-nav__list">
<li class="md-nav__item">
<a class="md-nav__link" href="#constructeur_1">
    Constructeur
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#methodes_1">
    Méthodes
  </a>
</li>
</ul>
</nav>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#blockchaincontroller">
    BlockchainController
  </a>
<nav aria-label="BlockchainController" class="md-nav">
<ul class="md-nav__list">
<li class="md-nav__item">
<a class="md-nav__link" href="#constantes">
    Constantes
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#champs_1">
    Champs
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#methodes_2">
    Méthodes
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#constructeur_2">
    Constructeur
  </a>
<nav aria-label="Constructeur" class="md-nav">
<ul class="md-nav__list">
<li class="md-nav__item">
<a class="md-nav__link" href="#createtransaction">
    CreateTransaction
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#decryptjsonfile">
    DecryptJSONFile
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#deletewallet">
    DeleteWallet
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#generatejsonfile">
    GenerateJSONFile
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#generatejsonfile_1">
    GenerateJSONFile
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#getaccountfromprivatekey">
    GetAccountFromPrivateKey
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#getallblocks">
    GetAllBlocks
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#getalltransacfrompublicaddress">
    GetAllTransacFromPublicAddress
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#getbalanceatallblocks">
    GetBalanceAtAllBlocks
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#getlastblock">
    GetLastBlock
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#getbalanceineth">
    GetBalanceInETH
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#getpublicaddresswithwalletindex">
    GetPublicAddressWithWalletIndex
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#getuserwallets">
    GetUserWallets
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#importaccountwithfile">
    ImportAccountWithFile
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#importaccountwithprivatekey">
    ImportAccountWithPrivateKey
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#isaddressvalid">
    isAddressValid
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#keystoredirectorycheck">
    KeystoreDirectoryCheck
  </a>
</li>
</ul>
</nav>
</li>
</ul>
</nav>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#appcontroller">
    AppController
  </a>
<nav aria-label="AppController" class="md-nav">
<ul class="md-nav__list">
<li class="md-nav__item">
<a class="md-nav__link" href="#champs_2">
    Champs
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#methodes_3">
    Méthodes
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#constructeur_3">
    Constructeur
  </a>
<nav aria-label="Constructeur" class="md-nav">
<ul class="md-nav__list">
<li class="md-nav__item">
<a class="md-nav__link" href="#checkifsettingaresaved">
    CheckIfSettingAreSaved
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#savesettings">
    SaveSettings
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#showauthenticatordialogbox">
    ShowAuthenticatorDialogBox
  </a>
</li>
</ul>
</nav>
</li>
</ul>
</nav>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#settings">
    Settings
  </a>
<nav aria-label="Settings" class="md-nav">
<ul class="md-nav__list">
<li class="md-nav__item">
<a class="md-nav__link" href="#champs_3">
    Champs
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#methodes_4">
    Méthodes
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#constructeur_4">
    Constructeur
  </a>
<nav aria-label="Constructeur" class="md-nav">
<ul class="md-nav__list">
<li class="md-nav__item">
<a class="md-nav__link" href="#getcontactpublickeywithindex">
    GetContactPublicKeyWithIndex
  </a>
</li>
</ul>
</nav>
</li>
</ul>
</nav>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#contact">
    Contact
  </a>
<nav aria-label="Contact" class="md-nav">
<ul class="md-nav__list">
<li class="md-nav__item">
<a class="md-nav__link" href="#champs_4">
    Champs
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#constructeur_5">
    Constructeur
  </a>
</li>
</ul>
</nav>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#user">
    User
  </a>
<nav aria-label="User" class="md-nav">
<ul class="md-nav__list">
<li class="md-nav__item">
<a class="md-nav__link" href="#constantes_1">
    Constantes
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#champs_5">
    Champs
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#constructeur_6">
    Constructeur
  </a>
</li>
</ul>
</nav>
</li>
</ul>
</nav>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="../Tests/">
        Tests
      </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="../conclusion/">
        Conclusion
      </a>
</li>
</ul>
</nav>
</li>
<li class="md-nav__item md-nav__item--nested">
<input class="md-nav__toggle md-toggle" data-md-toggle="__nav_6" id="__nav_6" type="checkbox"/>
<label class="md-nav__link" for="__nav_6">
          Annexes
          <span class="md-nav__icon md-icon"></span>
</label>
<nav aria-label="Annexes" class="md-nav" data-md-level="1">
<label class="md-nav__title" for="__nav_6">
<span class="md-nav__icon md-icon"></span>
          Annexes
        </label>
<ul class="md-nav__list" data-md-scrollfix="">
<li class="md-nav__item">
<a class="md-nav__link" href="../JournalDeBord/">
        Journal de bord
      </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="../tableDesIllustrations/">
        Table des illustrations
      </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="../planningAnnexe/">
        Planning
      </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="../codeSource/">
        Code source
      </a>
</li>
</ul>
</nav>
</li>
</ul>
</nav>
</div>
</div>
</div>
<div class="md-sidebar md-sidebar--secondary" data-md-component="sidebar" data-md-type="toc">
<div class="md-sidebar__scrollwrap">
<div class="md-sidebar__inner">
<nav aria-label="Table of contents" class="md-nav md-nav--secondary">
<label class="md-nav__title" for="__toc">
<span class="md-nav__icon md-icon"></span>
      Table of contents
    </label>
<ul class="md-nav__list" data-md-component="toc" data-md-scrollfix="">
<li class="md-nav__item">
<a class="md-nav__link" href="#jwtcontroller">
    JwtController
  </a>
<nav aria-label="JwtController" class="md-nav">
<ul class="md-nav__list">
<li class="md-nav__item">
<a class="md-nav__link" href="#constante">
    Constante
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#champs">
    Champs
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#constructeur">
    Constructeur
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#methodes">
    Méthodes
  </a>
<nav aria-label="Méthodes" class="md-nav">
<ul class="md-nav__list">
<li class="md-nav__item">
<a class="md-nav__link" href="#checktoken">
    CheckToken
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#checkuserauthenticator">
    CheckUserAuthenticator
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#checkuserlogin">
    CheckUserLogin
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#gettoken">
    GetToken
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#deserializeresponse">
    DeserializeResponse
  </a>
</li>
</ul>
</nav>
</li>
</ul>
</nav>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#wallet">
    Wallet
  </a>
<nav aria-label="Wallet" class="md-nav">
<ul class="md-nav__list">
<li class="md-nav__item">
<a class="md-nav__link" href="#constructeur_1">
    Constructeur
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#methodes_1">
    Méthodes
  </a>
</li>
</ul>
</nav>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#blockchaincontroller">
    BlockchainController
  </a>
<nav aria-label="BlockchainController" class="md-nav">
<ul class="md-nav__list">
<li class="md-nav__item">
<a class="md-nav__link" href="#constantes">
    Constantes
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#champs_1">
    Champs
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#methodes_2">
    Méthodes
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#constructeur_2">
    Constructeur
  </a>
<nav aria-label="Constructeur" class="md-nav">
<ul class="md-nav__list">
<li class="md-nav__item">
<a class="md-nav__link" href="#createtransaction">
    CreateTransaction
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#decryptjsonfile">
    DecryptJSONFile
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#deletewallet">
    DeleteWallet
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#generatejsonfile">
    GenerateJSONFile
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#generatejsonfile_1">
    GenerateJSONFile
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#getaccountfromprivatekey">
    GetAccountFromPrivateKey
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#getallblocks">
    GetAllBlocks
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#getalltransacfrompublicaddress">
    GetAllTransacFromPublicAddress
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#getbalanceatallblocks">
    GetBalanceAtAllBlocks
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#getlastblock">
    GetLastBlock
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#getbalanceineth">
    GetBalanceInETH
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#getpublicaddresswithwalletindex">
    GetPublicAddressWithWalletIndex
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#getuserwallets">
    GetUserWallets
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#importaccountwithfile">
    ImportAccountWithFile
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#importaccountwithprivatekey">
    ImportAccountWithPrivateKey
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#isaddressvalid">
    isAddressValid
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#keystoredirectorycheck">
    KeystoreDirectoryCheck
  </a>
</li>
</ul>
</nav>
</li>
</ul>
</nav>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#appcontroller">
    AppController
  </a>
<nav aria-label="AppController" class="md-nav">
<ul class="md-nav__list">
<li class="md-nav__item">
<a class="md-nav__link" href="#champs_2">
    Champs
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#methodes_3">
    Méthodes
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#constructeur_3">
    Constructeur
  </a>
<nav aria-label="Constructeur" class="md-nav">
<ul class="md-nav__list">
<li class="md-nav__item">
<a class="md-nav__link" href="#checkifsettingaresaved">
    CheckIfSettingAreSaved
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#savesettings">
    SaveSettings
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#showauthenticatordialogbox">
    ShowAuthenticatorDialogBox
  </a>
</li>
</ul>
</nav>
</li>
</ul>
</nav>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#settings">
    Settings
  </a>
<nav aria-label="Settings" class="md-nav">
<ul class="md-nav__list">
<li class="md-nav__item">
<a class="md-nav__link" href="#champs_3">
    Champs
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#methodes_4">
    Méthodes
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#constructeur_4">
    Constructeur
  </a>
<nav aria-label="Constructeur" class="md-nav">
<ul class="md-nav__list">
<li class="md-nav__item">
<a class="md-nav__link" href="#getcontactpublickeywithindex">
    GetContactPublicKeyWithIndex
  </a>
</li>
</ul>
</nav>
</li>
</ul>
</nav>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#contact">
    Contact
  </a>
<nav aria-label="Contact" class="md-nav">
<ul class="md-nav__list">
<li class="md-nav__item">
<a class="md-nav__link" href="#champs_4">
    Champs
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#constructeur_5">
    Constructeur
  </a>
</li>
</ul>
</nav>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#user">
    User
  </a>
<nav aria-label="User" class="md-nav">
<ul class="md-nav__list">
<li class="md-nav__item">
<a class="md-nav__link" href="#constantes_1">
    Constantes
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#champs_5">
    Champs
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#constructeur_6">
    Constructeur
  </a>
</li>
</ul>
</nav>
</li>
</ul>
</nav>
</div>
</div>
</div>
<div class="md-content" data-md-component="content">
<article class="md-content__inner md-typeset">
<h1 id="classes">Classes</h1>
<p><img src="./img/DiagrammeClasse.png" width="500"/>
fig{"./img/DiagrammeClasse.png", "Diagramme de classes", 80}</p>
<h2 id="jwtcontroller">JwtController</h2>
<h3 id="constante">Constante</h3>
<ul>
<li>LOGIN_URL : Route sur le script login.php de l'API.</li>
<li>AUTHENTICATOR_URL : Route sur le script authenticator.php de l'API.</li>
<li>GET_TOKEN_URL : Route sur le script tokenCreator.php de l'API.</li>
<li>CHECK_TOKEN_URL : Route sur le script tokenAuthenticator.php de l'API.</li>
</ul>
<h3 id="champs">Champs</h3>
<ul>
<li>client : HTTPClient connecté a l'API PHP.</li>
</ul>
<h3 id="constructeur">Constructeur</h3>
<p>Ce constructeur a comme unique tâche d'initialiser la propriété "URL" du champ "client" afin qu'il pointe sur le répertoire où se situe l'API.</p>
<h3 id="methodes">Méthodes</h3>
<h4 id="checktoken">CheckToken</h4>
<p>Cette méthode asynchrone prend en paramètre deux "string", un pour le token et un autre pour le mail. </p>
<p>Elle fait une requête sur l'API, permettant de vérifier un token "JWT".</p>
<p>Retourne un "string" avec comme valeur "ok" si le token est valide, et dans le cas contraire retourne le code d'erreur émis par la librairie Emmaref/JWT.</p>
<h4 id="checkuserauthenticator">CheckUserAuthenticator</h4>
<p>Cette méthode asynchrone prend en paramètre deux "string", un pour le mail et un autre pour le code.</p>
<p>Celle-ci fait une requête à l'API, permettant de vérifier le code Google Authenticator que l'utilisateur a fourni.</p>
<p>Retourne un "string" avec comme valeur "ok" si le token est valide, et dans le cas contraire "ko".</p>
<h4 id="checkuserlogin">CheckUserLogin</h4>
<p>Cette méthode asynchrone prend en paramètre deux "string", un pour le mail et un autre pour le password (mot de passe).</p>
<p>Celle-ci fait une requête à l'API, permettant de vérifier si l'email et le mot de passe que l'utilisateur fournit coïncident avec un des éléments présents dans la base de données.</p>
<p>Retourne un "string" avec comme valeur "ok" si le token est valide, et dans le cas contraire "ko".</p>
<h4 id="gettoken">GetToken</h4>
<p>Cette méthode asynchrone prend en paramètre un "string", qui est pour le mail.</p>
<p>Celle-ci fait une requête à l'API, permettant de recevoir un nouveau token "JWT". </p>
<p>Retourne un "string" avec comme valeur un token "JWT".</p>
<h4 id="deserializeresponse">DeserializeResponse</h4>
<p>Cette méthode prend en paramètre un "task&lt; string&gt;" response, il s'agit d'une tâche qui s'exécute de manière asynchrone.</p>
<p>Elle permet d'attendre la réponse complète de l'API et convertir la task "JSON" en "string".</p>
<h2 id="wallet">Wallet</h2>
<h3 id="constructeur_1">Constructeur</h3>
<p>Ce constructeur a comme paramètres un string nom ("Name"), un string "publicKey" et d'un string "path".</p>
<p>Celui-ci permet d'instancier un Wallet et d'assigner les valeurs.</p>
<h3 id="methodes_1">Méthodes</h3>
<h2 id="blockchaincontroller">BlockchainController</h2>
<h3 id="constantes">Constantes</h3>
<ul>
<li>BLOCKCHAIN_URL : Url pointant sur la blockchain.</li>
</ul>
<h3 id="champs_1">Champs</h3>
<ul>
<li>Wallets : Liste d'objets de type Wallet.</li>
</ul>
<h3 id="methodes_2">Méthodes</h3>
<h3 id="constructeur_2">Constructeur</h3>
<p>Ce constructeur permet d'instancier l'objet Web3 qui communique avec la blockchain.</p>
<h4 id="createtransaction">CreateTransaction</h4>
<p>Cette méthode prend en paramètre un "string" privateKey, un "string" publiKey et une "decimal" amount.</p>
<p>Son but est de permettre la création d'une transaction par l'utilisateur à une tierce personne. C'est pourquoi il faut renseigner l'adresse publique ainsi que le montant. L'adresse privée permet de signer la transaction sur la blockchain.</p>
<h4 id="decryptjsonfile">DecryptJSONFile</h4>
<p>Cette méthode prend en paramètre un "string" password et un "string" jsonPath.</p>
<p>Son but est de pouvoir prendre un portefeuille crypté sous forme de fichier JSON à un emplacement spécifique (jsonPath) et de pouvoir le décrypter à l'aide du code (password) afin d'y retirer les informations nécessaires. Il s'agit de préciser ici que le code doit être le même que celui utiliser pour son portefeuille à la création/importation.</p>
<h4 id="deletewallet">DeleteWallet</h4>
<p>Cette méthode prend en paramètre un "int" walletIndex et un "string" emailUser.</p>
<p>Son utilité est de pouvoir supprimer un portefeuille de sa liste "Wallets" de cette classe. </p>
<p>Pour ce faire, on cherche le "Wallet" suivant son index, ensuite on y extrait son champ "path" ainsi que son "name".</p>
<p>Enfin, on parcourt le dossier pour trouver tout fichier qui comporte le nom demandé. Sans oublier de le supprimer de notre Liste de portefeuille à l'index spécifié en paramètre.</p>
<h4 id="generatejsonfile">GenerateJSONFile</h4>
<p>Cette méthode prend en paramètre un "string" password, un "string" name et un "string" accountName.</p>
<p>Le but est de générer un fichier "JSON" dans un dossier spécifié. Il est également important de regarder si le fichier existe déjà, dans ce cas on fait apparaître un message pour informer l'utilisateur. Dans le cas contraire on créé le fichier "JSON" comportant les informations cryptées et un fichier "txt" qui contient la clé publique.</p>
<h4 id="generatejsonfile_1">GenerateJSONFile</h4>
<p>Cette méthode prend en paramètre en plus de celle ci-dessus un "Account" account. Ce type est nécessaire lors de l'import d'un fichier "JSON" puisqu’on est obligé de générer un "Account" pour récupérer la clé publique de ce portefeuille.</p>
<h4 id="getaccountfromprivatekey">GetAccountFromPrivateKey</h4>
<p>Cette méthode prend en paramètre un "string" privateKey.</p>
<p>Son utilité est de pouvoir créer et retourner un compte (Account) en utilisant sa clé privée.</p>
<h4 id="getallblocks">GetAllBlocks</h4>
<p>Retourne tous les blocs, avec leurs transactions, présents dans la blockchain.</p>
<h4 id="getalltransacfrompublicaddress">GetAllTransacFromPublicAddress</h4>
<p>Cette méthode prend en paramètre un "string" publicAdress.</p>
<p>Son utilité est de pouvoir obtenir toutes les transactions effectuées avec un certain portefeuille. Pour y arriver, on parcourt la liste des blocs fournie par la méthode <a href="#getallblocks">GetAllBlocks</a> pour y extraire toutes les transactions où l'adresse publique est présente. </p>
<p>Enfin, on retourne le dictionnaire de transaction "myTransac".</p>
<h4 id="getbalanceatallblocks">GetBalanceAtAllBlocks</h4>
<p>Cette méthode prend en paramètre un "string" adresse.</p>
<p>Pour chaque bloc présent dans la blockchain, on effectue une requête "GetBalance" ce qui nous permet d'extraire l'évolution de la quantité d'Etherum présente dans un portefeuille.</p>
<p>Elle retourne un dictionnaire avec comme clé le "TimeStamp" de chaque bloc et comme valeur associée la quantité d'Etherum disponible.</p>
<h4 id="getlastblock">GetLastBlock</h4>
<p>Cette méthode asynchrone prend en paramètre un "string" publicAddress.</p>
<p>Elle retourne le dernier id du bloc stocké dans la blockchain.</p>
<h4 id="getbalanceineth">GetBalanceInETH</h4>
<p>Cette méthode prend en paramètre un "string" adresse.</p>
<p>Son utilité est qu'elle prend la balance d'une clé publique en "wei" et la convertie en "Eth".</p>
<h4 id="getpublicaddresswithwalletindex">GetPublicAddressWithWalletIndex</h4>
<p>Cette méthode prend en paramètre un "int" index.</p>
<p>Son utilité est de pouvoir retourner la clé publique à un index spécifié (publicAddress) dans la Liste "Wallets".</p>
<h4 id="getuserwallets">GetUserWallets</h4>
<p>Cette méthode en paramètre un "string" path.</p>
<p>Son utilité est de pouvoir instancier les différents portefeuilles appartenant à l'utilisateur connecté, dans la Liste "Wallets".</p>
<p>Enfin, je retourne cette variable "result" qui contient une Liste de wallet.</p>
<h4 id="importaccountwithfile">ImportAccountWithFile</h4>
<p>Cette méthode prend en paramètre un "string" password, un "string" path, un "string" name et un "string" accountName.</p>
<p>Son but est de pouvoir instancier une variable de type "Account" nécessaire à la méthode <a href="#generatejsonfile">GenerateJsonfile</a>. Mais avant de pouvoir de faire cela, il est nécessaire d'utiliser la méthode <a href="#decryptjsonfile">DecryptJSONFile</a>.</p>
<h4 id="importaccountwithprivatekey">ImportAccountWithPrivateKey</h4>
<p>Cette méthode prend en paramètre un "string" privateKey, un "string" password, un "string" email et un "string" walletName.</p>
<p>Son but est de pouvoir instancier une variable de type "Account" nécessaire à la méthode <a href="#generatejsonfile">GenerateJsonfile</a>.</p>
<h4 id="isaddressvalid">isAddressValid</h4>
<p>Cette méthode prend en paramètre un "string" privateKey.</p>
<p>??????</p>
<h4 id="keystoredirectorycheck">KeystoreDirectoryCheck</h4>
<p>Cette méthode prend en paramètre un "string" email.</p>
<p>Son but est de vérifier si le répertoire devant contenir les différents portefeuilles de l'utilisateur a été préalablement créé.</p>
<h2 id="appcontroller">AppController</h2>
<p>Cette classe représente le modèle de données nécessaire au bon fonctionnement du programme, c'est cet objet qui est transmis entre les différentes vues lors de leurs instanciations. </p>
<h3 id="champs_2">Champs</h3>
<ul>
<li>User : Objet de type User.</li>
<li>Bc : Objet de type BlockchainController.</li>
<li>Settings : Objet de type Settings.</li>
</ul>
<h3 id="methodes_3">Méthodes</h3>
<h3 id="constructeur_3">Constructeur</h3>
<p>Un "AppController" est caractérisé par trois valeurs. Il s'agit d'un "User" user, d'un "BlockchainController" bc et d'un "Settings" settings.</p>
<p>Un constructeur est mis en place avec un paramètre "string" userEmail. Dans celle-ci on indique que le "User" devient un nouvel utilisateur (new User) avec comme paramètre le userEmail. Enfin j'appelle la méthode <a href="#checkifsettingaresaved">CheckIfSettingsAreSaved</a>.</p>
<h4 id="checkifsettingaresaved">CheckIfSettingAreSaved</h4>
<p>Cette méthode permet de vérifier si des paramètres ont déjà été enregistrés. Dans le cas où ça le serait, il instancie la classe "Settings" à l'aide de l'objet sérialisé présent dans le répertoire propre à chaque utilisateur.</p>
<h4 id="savesettings">SaveSettings</h4>
<p>Cette méthode permet de sauvegarder les paramètres en sérialisant la classe "Settings" dans le répertoire de l'utilisateur connecter, lors de la fermeture de l'application.</p>
<h4 id="showauthenticatordialogbox">ShowAuthenticatorDialogBox</h4>
<p>Cette méthode prend en paramètre une "From" frmOwner.</p>
<p>Cette méthode permet d'afficher la "pop-up" authenticator et d'attendre un résultat de celle-ci.</p>
<p>Enfin je retourne le résultat de celle-ci.</p>
<h2 id="settings">Settings</h2>
<p>Cette classe permet de lister les différents contacts créés par l'utilisateur. Permets également d'enregistrer la devise utilisée par l'application.</p>
<h3 id="champs_3">Champs</h3>
<ul>
<li>Contacts : Liste d'objets de type Contact.</li>
<li>currency : La devise utilisée par l'utilisateur.</li>
</ul>
<h3 id="methodes_4">Méthodes</h3>
<h3 id="constructeur_4">Constructeur</h3>
<p>Dans ce constructeur j'instancie la devise (currency) à "USD" par défaut. De plus, je créer une nouvelle liste d'objet "Contact" vide.</p>
<h4 id="getcontactpublickeywithindex">GetContactPublicKeyWithIndex</h4>
<p>Cette méthode prend en paramètre un "int" index.</p>
<p>Elle retourne un "string" avec la publicKey d'un contact dans la Liste "Contacts" à l'index spécifié.</p>
<h2 id="contact">Contact</h2>
<p>Cette classe représente la structure de donnée d'un contact nécessaire à mon application.</p>
<h3 id="champs_4">Champs</h3>
<ul>
<li>name : Nom du contact.</li>
<li>publicKey : Clé publique du contact.</li>
</ul>
<h3 id="constructeur_5">Constructeur</h3>
<p>Ce constructeur prend en paramètre un "string" name et un "string" publicKey, pour assigné directement les valeurs aux champs.</p>
<h2 id="user">User</h2>
<p>Cette classe représente la structure de donnée d'un utilisateur nécessaire à mon application.</p>
<h3 id="constantes_1">Constantes</h3>
<h3 id="champs_5">Champs</h3>
<ul>
<li>Email : Email avec laquelle l'utilisateur s'est connecté.</li>
<li>Token : Token JWT que reçoit l'utilisateur une fois connecté.</li>
<li></li>
</ul>
<h3 id="constructeur_6">Constructeur</h3>
<p>Ce constructeur prend en paramètre un "string" email, afin d'assigne directement la valeur au champ Email a l'instanciation de cette classe.</p>
</article>
</div>
</div>
</main>
<footer class="md-footer">
<nav aria-label="Footer" class="md-footer__inner md-grid">
<a aria-label="Previous: Encryption de base de données" class="md-footer__link md-footer__link--prev" href="../10_EncryptionBdd/" rel="prev">
<div class="md-footer__button md-icon">
<svg viewbox="0 0 24 24" xmlns="http://www.w3.org/2000/svg"><path d="M20 11v2H8l5.5 5.5-1.42 1.42L4.16 12l7.92-7.92L13.5 5.5 8 11h12z"></path></svg>
</div>
<div class="md-footer__title">
<div class="md-ellipsis">
<span class="md-footer__direction">
                Previous
              </span>
              Encryption de base de données
            </div>
</div>
</a>
<a aria-label="Next: Tests" class="md-footer__link md-footer__link--next" href="../Tests/" rel="next">
<div class="md-footer__title">
<div class="md-ellipsis">
<span class="md-footer__direction">
                Next
              </span>
              Tests
            </div>
</div>
<div class="md-footer__button md-icon">
<svg viewbox="0 0 24 24" xmlns="http://www.w3.org/2000/svg"><path d="M4 11v2h12l-5.5 5.5 1.42 1.42L19.84 12l-7.92-7.92L10.5 5.5 16 11H4z"></path></svg>
</div>
</a>
</nav>
<div class="md-footer-meta md-typeset">
<div class="md-footer-meta__inner md-grid">
<div class="md-footer-copyright">
        
        
          Made with
          <a href="https://squidfunk.github.io/mkdocs-material/" rel="noopener" target="_blank">
            Material for MkDocs
          </a>
 ... <a class="link--pdf-download" download href="../pdf/document.pdf" title="PDF">download PDF</a></div>
</div>
</div>
</footer>
</div>
<div class="md-dialog" data-md-component="dialog">
<div class="md-dialog__inner md-typeset"></div>
</div>
<script id="__config" type="application/json">{"base": "..", "features": [], "translations": {"clipboard.copy": "Copy to clipboard", "clipboard.copied": "Copied to clipboard", "search.config.lang": "en", "search.config.pipeline": "trimmer, stopWordFilter", "search.config.separator": "[\\s\\-]+", "search.placeholder": "Search", "search.result.placeholder": "Type to start searching", "search.result.none": "No matching documents", "search.result.one": "1 matching document", "search.result.other": "# matching documents", "search.result.more.one": "1 more on this page", "search.result.more.other": "# more on this page", "search.result.term.missing": "Missing", "select.version.title": "Select version"}, "search": "../assets/javascripts/workers/search.fcfe8b6d.min.js", "version": null}</script>
<script src="../assets/javascripts/bundle.b1047164.min.js"></script>
<script src="https://unpkg.com/mermaid@8.5.1/dist/mermaid.min.js"></script>
</body>
</html>